#ifndef _WEBKITAG_OBJECT_DATA_H_INCLUDED

#include "ag.h"
#include "Shared.h"
#include "DeprecatedCString.h"

namespace WebCore {

class CachedEmbedObject;
class WebKitAGObjectData : public Shared<WebKitAGObjectData>
{
public:
	WebKitAGObjectData();
	~WebKitAGObjectData();

	void copyURL(const DeprecatedCString& url);
	void copyServiceType(const DeprecatedCString& serviceType);
	void setIsMultimedia(bool isMultimedia);
	void allocParams(int nParams);
	void addParamValue(const DeprecatedCString& paramName, const DeprecatedCString& paramValue, const int& at);
	void copyRawData(const char* rawData, const int size);

	char* url() const {return m_ag_url;}
	char* serviceType() const {return m_ag_serviceType;}
	bool isMultimedia() const {return m_ag_MultiMedia;}
	int paramsSize() const {return m_ag_params_size;}
	void getNthParam(int n, char** name, char** value) const {*name = m_ag_paramNames[n]; *value = m_ag_paramValues[n];}
	AGRawData_t data() {return m_ag_objectData;}
	void setCachedEmbedObject(CachedEmbedObject * pCachedEmbedObject) { m_pCachedEmbedObject = pCachedEmbedObject; }
	CachedEmbedObject * getCachedEmbedObject() const { return m_pCachedEmbedObject; }
	void setInitialized() { m_bIsInitialized = true; }
	bool isInitialized() const { return m_bIsInitialized; }

private:
	int m_ag_params_size;
	char** m_ag_paramNames;
	char** m_ag_paramValues;
	char* m_ag_serviceType;
	char* m_ag_url;
	bool m_ag_MultiMedia;
	AGRawData_t m_ag_objectData;
	CachedEmbedObject * m_pCachedEmbedObject;		// The Cached object we're connected to. We don't own this in any way!
	bool m_bIsInitialized;
};

}
#endif
