#ifndef CachedEmbedObject_h
#define CachedEmbedObject_h

#include "CachedResource.h"
#include "TextEncoding.h"
#include "DocLoader.h"

namespace WebCore {

    class CachedEmbedObject : public CachedResource {
    public:
        CachedEmbedObject(DocLoader*, const String& URL, CachePolicy);
        virtual ~CachedEmbedObject();

        virtual void ref(CachedResourceClient*);
        virtual void data(PassRefPtr<SharedBuffer> data, bool allDataReceived);
        virtual void error();       

        void checkNotify();
		const char* getData(unsigned int* size);

    private:
		PassRefPtr<SharedBuffer> m_data;
        bool m_errorOccurred;
    };
}

#endif
