//this include is necessary to build on mac.
//otherwise we get this compiler error: if you use new/delete make sure to include config.h at the top of the file
#include "config.h"
#include "Screen.h"
#include "FloatRect.h"

#if PLATFORM(MAC)
#include "Page.h"
//#include "WebCorePageBridge.h"

//#include "IntRect.h"
//#include "Frame.h"
#endif

namespace WebCore {

#ifdef AG_MAC_PLATFORM
NSRect flipScreenRect(NSRect rect)
{
    rect.origin.y = NSMaxY([[[NSScreen screens] objectAtIndex:0] frame]) - NSMaxY(rect);
    return rect;
}

NSPoint flipScreenPoint(NSPoint point)
{
    point.y = NSMaxY([[[NSScreen screens] objectAtIndex:0] frame]) - point.y;
    return point;
}
#endif

FloatRect scaleScreenRectToPageCoordinates(const FloatRect& rect, const Page*)
{
    return rect;
}

FloatRect scalePageRectToScreenCoordinates(const FloatRect& rect, const Page*)
{
    return rect;
}

int screenDepth(const Page* page)
{
	return 32;
}

float scaleFactor(const Page* page)
{
	return 1.0f;	
}

FloatRect screenRect(const Page* page)
{
	return FloatRect(0,0, 800, 600);	
}

FloatRect usableScreenRect(const Page* page)
{
	return FloatRect(0,0, 800, 600);	
}

} // namespace WebCore




    

