/*************************************************************************
*
* ADOBE CONFIDENTIAL
* ___________________
*
*  Copyright 2007 Adobe Systems Incorporated
*  All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains
* the property of Adobe Systems Incorporated and its suppliers,
* if any.  The intellectual and technical concepts contained
* herein are proprietary to Adobe Systems Incorporated and its
* suppliers and may be covered by U.S. and Foreign Patents,
* patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material
* is strictly forbidden unless prior written permission is obtained
* from Adobe Systems Incorporated.
**************************************************************************/
#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include "CString.h"
#include "Node.h"
#include "FileChooser.h"
#include "Font.h"
#include "IntPoint.h"
#include "Widget.h"
#include "GraphicsContext.h"
#include "Cursor.h"
#include "loader.h"
#include "Frame.h"
#include "FrameView.h"
#include "FrameLoadRequest.h"
#include "KURL.h"
#include "PlatformScrollBar.h"
#include "ScrollBar.h"
#include "Page.h"
#include "Path.h"
#include "PlatformMouseEvent.h"
#include "CookieJar.h"
#include "Screen.h"
#include "History.h"
#include "Language.h"
#include "LocalizedStrings.h"
#include "PlugInInfoStore.h"
#include "RenderTheme.h"
#include "ResourceHandle.h"
#include "ResourceHandleClient.h"
#include "ResourceLoader.h"
#include "ChromeClientAG.h"
#include "TextBoundaries.h"
#include "AXObjectCache.h"
#include "PopupMenu.h"
#include "ChromeClientAG.h"
#include "EditCommand.h"
#include "Icon.h"
#include "IconLoader.h"
#include "IconDatabase.h"
#include "CachedResource.h"
#include "ag.h"

#if PLATFORM(MAC)
#include "ScrollView.h"
#include "ImageDocumentMac.h"
#include "DocumentLoader.h"
#endif

namespace WebCore {

void FrameView::updateBorder() { agNotImplemented(); }

#if PLATFORM(MAC)
void finishImageLoad(Document*, CachedImage*, const void* imageData, size_t imageDataSize){ agNotImplemented(); }
bool DocumentLoader::getResponseModifiedHeader(String& modified) const { agNotImplemented(); return false; }
#endif

bool AXObjectCache::gAccessibilityEnabled = false;

int screenDepthPerComponent(const Page*) { agNotImplemented(); return 8; }
bool screenIsMonochrome(const Page*) { agNotImplemented(); return false; }

PluginInfo* PlugInInfoStore::createPluginInfoForPluginAtIndex(unsigned) { return 0;}
unsigned PlugInInfoStore::pluginCount() const { return 0; }
bool PlugInInfoStore::supportsMIMEType(const String&) { return false; }
void refreshPlugins(bool) { }

Vector<char> ServeSynchronousRequest(Loader*, DocLoader*, const ResourceRequest&, ResourceResponse&){ agNotImplemented(); return Vector<char>(); }

void CheckCacheObjectStatus(DocLoader*, CachedResource*) { }
bool CheckIfReloading(DocLoader*) { return false; }
bool IsResponseURLEqualToURL(PlatformResponse , const String&) { return false; }
DeprecatedString ResponseURL(PlatformResponse) { return DeprecatedString(); }
DeprecatedString ResponseMIMEType(PlatformResponse) { return DeprecatedString(); }
bool ResponseIsMultipart(PlatformResponse) { return false; }
time_t CacheObjectExpiresTime(DocLoader*, PlatformResponse) { return 0; }

bool ChromeClientAG::canRunModal() { agNotImplemented(); return false; }
void ChromeClientAG::runModal() { }
bool ScrollView::inWindow() const { agNotImplemented(); return true; }
void Widget::setIsSelected(bool isSelected) { agNotImplemented(); }

Icon::Icon() { agNotImplemented(); }
Icon::~Icon() { agNotImplemented(); }
PassRefPtr<Icon> Icon::newIconForFile(const String& filename) { agNotImplemented(); return PassRefPtr<Icon>(new Icon()); }
void Icon::paint(GraphicsContext*, const IntRect&) { agNotImplemented(); }

void systemBeep() {}

} // namespace WebCore

using namespace WebCore;

/* See WebKitAG\win\WebCoreLocalizedStrings.cpp */
// WEBC: TODO: We need localized versions of the following. Get from host
String WebCore::searchableIndexIntroduction() { return String("This is a searchable index. Enter search keywords: "); }
String WebCore::submitButtonDefaultLabel() { return String("Submit"); }
String WebCore::inputElementAltText() { return String("Submit"); }
String WebCore::resetButtonDefaultLabel() { return String("Reset"); }
String WebCore::fileButtonChooseFileLabel() { return String("Choose File"); }
String WebCore::fileButtonNoFileSelectedLabel() { return String("no file selected"); }
String WebCore::copyImageUnknownFileLabel() { return String("Image Unknown File"); }

/* AG does not do context menu -- stub them */
String WebCore::contextMenuItemTagOpenLinkInNewWindow() { return String(); }
String WebCore::contextMenuItemTagDownloadLinkToDisk() { return String(); }
String WebCore::contextMenuItemTagCopyLinkToClipboard() { return String(); }
String WebCore::contextMenuItemTagOpenImageInNewWindow() { return String(); }
String WebCore::contextMenuItemTagDownloadImageToDisk() { return String(); }
String WebCore::contextMenuItemTagCopyImageToClipboard() { return String(); }
String WebCore::contextMenuItemTagOpenFrameInNewWindow() { return String(); }
String WebCore::contextMenuItemTagCopy() { return String(); }
String WebCore::contextMenuItemTagGoBack() { return String(); }
String WebCore::contextMenuItemTagGoForward() { return String(); }
String WebCore::contextMenuItemTagStop() { return String(); }
String WebCore::contextMenuItemTagReload() { return String(); }
String WebCore::contextMenuItemTagCut() { return String(); }
String WebCore::contextMenuItemTagPaste() { return String(); }
String WebCore::contextMenuItemTagNoGuessesFound() { return String(); }
String WebCore::contextMenuItemTagIgnoreSpelling() { return String(); }
String WebCore::contextMenuItemTagLearnSpelling() { return String(); }
String WebCore::contextMenuItemTagSearchWeb() { return String(); }
String WebCore::contextMenuItemTagLookUpInDictionary() { return String(); }
String WebCore::contextMenuItemTagOpenLink() { return String(); }
String WebCore::contextMenuItemTagIgnoreGrammar() { return String(); }
String WebCore::contextMenuItemTagSpellingMenu() { return String(); }
String WebCore::contextMenuItemTagShowSpellingPanel(bool show) { return String(); }
String WebCore::contextMenuItemTagCheckSpelling() { return String(); }
String WebCore::contextMenuItemTagCheckSpellingWhileTyping() { return String(); }
String WebCore::contextMenuItemTagCheckGrammarWithSpelling() { return String(); }
String WebCore::contextMenuItemTagFontMenu() { return String(); }
String WebCore::contextMenuItemTagBold() { return String(); }
String WebCore::contextMenuItemTagItalic() { return String(); }
String WebCore::contextMenuItemTagUnderline() { return String(); }
String WebCore::contextMenuItemTagOutline() { return String(); }
String WebCore::contextMenuItemTagWritingDirectionMenu() { return String(); }
String WebCore::contextMenuItemTagDefaultDirection() { return String(); }
String WebCore::contextMenuItemTagLeftToRight() { return String(); }
String WebCore::contextMenuItemTagRightToLeft() { return String(); }

#if PLATFORM(MAC)
String WebCore::contextMenuItemTagSearchInSpotlight() { return String(); }
String WebCore::contextMenuItemTagShowFonts() { return String(); }
String WebCore::contextMenuItemTagStyles() { return String(); }
String WebCore::contextMenuItemTagShowColors() { return String(); }
String WebCore::contextMenuItemTagSpeechMenu() { return String(); }
String WebCore::contextMenuItemTagStartSpeaking() { return String(); }
String WebCore::contextMenuItemTagStopSpeaking() { return String(); }
#endif

String WebCore::contextMenuItemTagInspectElement() { return String(); }
String WebCore::searchMenuNoRecentSearchesText() { return String(); }
String WebCore::searchMenuRecentSearchesText() { return String(); }
String WebCore::searchMenuClearRecentSearchesText() { return String(); }
String WebCore::AXWebAreaText() { return String(); }
String WebCore::AXLinkText() { return String(); }
String WebCore::AXListMarkerText() { return String(); }
String WebCore::AXImageMapText() { return String(); }
String WebCore::AXHeadingText() { return String(); }
String WebCore::unknownFileSizeText() { return String(); }


