#ifndef AG_UTILS_H_DEFINED__
#define AG_UTILS_H_DEFINED__

#include "ag.h"

void ag_user_to_device (AGContext_t *cr, double *x, double *y);
void ag_device_to_user (AGContext_t *cr, double *x, double *y);
void ag_user_to_device_distance (AGContext_t *cr, double *x, double *y);
void ag_device_to_user_distance (AGContext_t *cr, double *dx, double *dy);
void ag_translate(AGContext_t *cr, double dx, double dy);
void ag_scale(AGContext_t *cr, double dx, double dy);
void ag_rotate(AGContext_t *cr, double angle);
void ag_init_matrix_to_identity(AGMatrix_t* m);
void ag_matrix_init_scale(AGMatrix_t* m, double sx, double sy);
void ag_matrix_transform_distance (const AGMatrix_t *matrix, double *dx, double *dy);
AGImage_t* ag_image_create (unsigned char *data, AGImageFormat_t format,int width, int height, int stride, int depth);
void ag_image_destroy(AGImage_t* agImage);

#endif //AG_UTILS_H_DEFINED__
